/*
*  Rubrica
*  file: file_utils.h
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __RUBRICA_FILE_UTILS_H
#define __RUBRICA_FILE_UTILS_H

#include <gnome.h>
#include <libxml/tree.h>
#include <libxml/parser.h>

#include "rubrica.h"

gint rubrica_file_get_fileformat(xmlDocPtr doc);
gboolean rubrica_file_is_start(void);
void rubrica_file_set_start(gboolean state);

gboolean rubrica_file_has_extension(gchar *fn);

void rubrica_file_split(gchar *file, gchar **f, gchar **ext, gint *n);

void rubrica_file_do_backup(Rubrica *rubrica, gchar *old_file_name);
void rubrica_file_do_bak_backup(Rubrica *rubrica, gchar *filename);

int rubrica_file_str2int(gchar *str);

#endif
