/*
*  Rubrica
*  file: preview_cb.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "preview.h"
#include "preview_cb.h"
#include "preview_int.h"
#include "file.h"
#include "dialog.h"

/*
void
on_about_preview_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  about_preview();
}
*/


/*    Open file, after shown it in preview 
*/
void
on_open_preview_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  gchar *filename;
  gboolean loaded;
  RubricaErrorType err;
  
  filename = rubrica_preview_get_filename();  
  loaded =  rubrica_file_load_xmlfile(filename, &err);
  if (!loaded)
    rubrica_dialog_error_loading_file(filename, err);

  close_preview_cb(NULL, NULL);
}


void
close_preview_cb               (GtkButton       *button,
                                gpointer         user_data)
{
//  GtkWidget *preview;
  GtkWidget *filesel;
  
//  preview = rubrica_preview_get_window();
  filesel = rubrica_preview_get_file_selection();
//  gtk_widget_destroy(preview);
  gtk_widget_destroy(filesel);  
}

/* when the ok button is clicked in the file open dialog 
   based on gxmlviewer by Sean Stuckless
 */
void
load_preview_cb (GtkButton *button, gpointer user_data)
{
  GtkWidget *fileDialog = user_data;
  
  if (fileDialog != NULL) 
    {
      gchar *filename;
      
      filename = g_strdup(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileDialog)));
      
      if (filename == NULL)
	{
	  printf("\nCan't read requested file!!");
	} 
      else 
	{
//	  GtkWidget *preview;
	  GtkWidget *ctree;
	  
//	  preview = rubrica_preview_get_window();
	  ctree = gtk_object_get_data(GTK_OBJECT(fileDialog), "ctree");
	  
	  if (ctree != NULL) 
	    {
	      RubricaErrorType error = RE_NO_ERROR;
	      
	      g_print("\nLoading %s", filename);
	      gtk_clist_clear(GTK_CLIST(ctree)); 
	      if (rubrica_preview_show_file(filename, ctree, &error)) 
		{
		  /* unable to process file */
		}
	    }
	  else 
	    {
	      printf("\nctree is null!!\n");
	    }
	}
    }
}
