/*
*  Rubrica
*  file: preview_int.c
*        Build window that will show the content of a .rub file
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 * NON MODIFICARE QUESTO FILE - generato automaticamente da Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "preview_cb.h"
#include "preview_int.h"
#include "rubrica_ui.h"
#include "utils.h"


GtkWidget *RubricaPreviewFs;
gchar *filename;


GtkWidget*
create_RubricaPreview (void)
{
  GtkWidget *frame2;
  GtkWidget *vbox2;
  GtkWidget *hbox;
  GtkWidget *main_box;
  GtkWidget *scrolledwindow1;
  GtkWidget *viewport1;
  GtkWidget *button1;

  GtkWidget *ctree;
//  GtkWidget *label;
  GtkWidget *label1;
  GtkWidget *label2;

  GtkWidget *ok_button1;
  GtkWidget *cancel_button1;

  GtkTooltips *tooltip;

  rubrica_utils_add_tooltip(tooltip);

  /* File selection */
  RubricaPreviewFs = gtk_file_selection_new (_("Rubrica Preview file selection"));
  gtk_object_set_data (GTK_OBJECT (RubricaPreviewFs), "RubricaPreviewFs", RubricaPreviewFs);
  gtk_container_set_border_width (GTK_CONTAINER (RubricaPreviewFs), 10);
  gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION (RubricaPreviewFs));

  main_box = GTK_FILE_SELECTION (RubricaPreviewFs)->main_vbox;

  ok_button1 = GTK_FILE_SELECTION (RubricaPreviewFs)->ok_button;
  gtk_object_set_data (GTK_OBJECT (RubricaPreviewFs), "ok_button1", ok_button1);
  GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);
  gtk_widget_show (ok_button1);

  cancel_button1 = GTK_FILE_SELECTION (RubricaPreviewFs)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (RubricaPreviewFs), "cancel_button1", cancel_button1);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);
  gtk_widget_show (cancel_button1);

  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip(GTK_TOOLTIPS(tooltip), ok_button1, 
		       _("Open the previewed file in rubrica"), NULL);

  frame2 = rubrica_ui_frame_new(_(" Rubrica Preview "));
  gtk_widget_set_usize(frame2, 100, 150);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 2);
  gtk_box_pack_start(GTK_BOX(main_box), frame2, TRUE, TRUE, 2);
  gtk_widget_show (frame2);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_container_add(GTK_CONTAINER (frame2), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 2);
  gtk_widget_show (vbox2);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 5);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), 
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrolledwindow1);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport1);
  gtk_widget_show (viewport1);

  /* Gtk CTree */
//  rubrica_preview_create_model();
//  rubrica_preview_create_view_with_model();
/*
  ctree = gtk_ctree_new (2,0);
  gtk_widget_ref (ctree);
  gtk_object_set_data_full (GTK_OBJECT (RubricaPreviewFs), "ctree", ctree,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (viewport1), ctree);
  gtk_container_set_border_width (GTK_CONTAINER (ctree), 0);
  gtk_clist_column_titles_show(GTK_CLIST (ctree));
  gtk_clist_set_column_width (GTK_CLIST (ctree), 0, 150);
  gtk_clist_set_column_width (GTK_CLIST (ctree), 0, 150);
  gtk_widget_show (ctree);

  label = gtk_label_new ("");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (ctree), 0, label);

  label = gtk_label_new ("");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (ctree), 1, label);
*/

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox2), hbox, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);
  gtk_widget_show(hbox);

  label1 = gtk_label_new(_("addresses in address book: "));
  gtk_box_pack_start(GTK_BOX(hbox), label1, FALSE, FALSE, 0);
  gtk_widget_show(label1);

  label2 = gtk_label_new("");
  gtk_object_set_data(GTK_OBJECT (ctree), "addresses_read", label2);  
  gtk_box_pack_start(GTK_BOX(hbox), label2, FALSE, FALSE, 10);
  gtk_widget_show(label2);  

  button1 = gtk_button_new_with_label (_("Preview"));
  gtk_object_set_data(GTK_OBJECT (RubricaPreviewFs), "preview_open", button1);
  gtk_box_pack_start(GTK_BOX(hbox), button1, TRUE, FALSE, 5);
  gtk_widget_show (button1);

  g_signal_connect (G_OBJECT (RubricaPreviewFs), "delete_event",
		    G_CALLBACK(close_preview_cb),NULL);
  
  g_signal_connect (G_OBJECT (ok_button1), "clicked",
		    G_CALLBACK(on_open_preview_clicked), NULL);
  g_signal_connect (G_OBJECT (cancel_button1), "clicked",
		    G_CALLBACK(close_preview_cb), NULL);
  
  g_signal_connect (G_OBJECT (button1), "clicked",
		    G_CALLBACK(load_preview_cb), RubricaPreviewFs);
  

  return RubricaPreviewFs;
}


GtkWidget *rubrica_preview_get_file_selection()
{
  return GTK_WIDGET(RubricaPreviewFs);
}

void rubrica_preview_set_filename(gchar *file)
{
  if(filename)
    g_free(filename);

  filename = g_strdup(file);
}

gchar *rubrica_preview_get_filename(void)
{
  return (gchar*) filename;
}

      
