#include <gnome.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "prefer.h"

gchar buf[128];
gboolean log_enabled = TRUE;
gchar *log_file = NULL;
FILE  *log = NULL;

void rubrica_log_init_log_file(void)
{
  gchar *rubrica_home;
  time_t curtime; 
  struct tm *loctime; 

  g_print("\nRubrica: opening log file..."); 

  curtime = time(NULL); 
  loctime = localtime(&curtime);
  strftime(buf, 128, "\nRubrica starting: %A %B %Y at %I:%M", loctime); 

  rubrica_home = rubrica_preferences_get_rubrica_home();

  if (g_file_exists(rubrica_home))
    log_file = g_strdup_printf("%s/rubrica.log", rubrica_home);
  else
    log_file = g_strdup_printf("%s/rubrica.log", g_get_home_dir());

  log = fopen(log_file, "a+");

  if(log == NULL)
    { 
      g_print("\nRubrica: can't open log file %s)", log_file); 
    } 
  else 
    {  
      g_print("\nRubrica: log file %s opened", log_file); 

      fprintf (log, "%s", buf);  
      fflush(log);
    } 

  g_free(log_file);
} 


void rubrica_log_write_log(gchar *str)
{
/*
  if (!log_enabled)
    return;
*/

  if (!log)
    return;

  g_print("\n%s", str);
  fprintf(log, "%s", str);  
  fflush(log);
}


void rubrica_log_close_log_file(void)
{
  time_t curtime; 
  struct tm *loctime; 

  if (!log)
    return;
  
  curtime = time(NULL); 
  loctime = localtime(&curtime);
  strftime(buf, 128, "\nRubrica closed: %A %B %Y at %I:%M", loctime);

  fprintf (log, "%s\n\n", buf);  
  
  fflush(log);
  fclose(log);
}
